#!/usr/bin/perl -w

# mailman.pl : proto de rception et traitement de mails avec pices jointes
#
# Le principe du test : J'ai cr un user mailman.
# dans sa homedir j'ai modifi ' la main !' le fichier .qmail
# Il ne contient plus (hors commentaires) que 
# |./bin/mailman.pl
#
# Pascal Schirrmann le 8 mai 2006
use strict;

# ma manire d'instller les progs :
# les .pl (et les .sh, d'ailleurs) sont dans ~mailman/bin
# Pour ne pas 'polluer la machine 'hte', les libs spcifiques sont dans ../lib
# donc on enrichit le PATH de recherche des librairies :
use FindBin;
use lib "$FindBin::Bin/../lib";

# la librairie suivante vient du CPAN : j'ai rcupr 
#  Email-MIME-1.82.tar.gz 
# C'est celle qui permet de parser un message en format MIME
# et j'ai extrait MIME.pl que j'ai install dans ../lib/Email/
# il m'a aussi fallu faire de mme avec  Email-MIME-Encodings-1.3,
# Email-MIME-ContentType-1.01 et Email-Simple-1.92
use Email::MIME;

# Source CPAN galement pour cette librairie qui permet de rcuprer les 
# pices jointes
# Email-MIME-Attachment-Stripper-1.31 
# pour un bon fonctionnement, j'ai galement du ajouter :
# Email-MessageID-1.31.tar.gz  Email-Address-1.80.tar.gz
# Email-MIME-Encodings-1.3.tar.gz Email-MIME-Modifier-1.42.tar.gz
use Email::MIME::Attachment::Stripper;

# Enfin, pour le prototype, on rpond (par mail !)  l'expditeur.
# Pour cela, utilisation d'une librairie prsente par dfaut sur SME
# Il serait peut-tre possible dd'envoyer un mail paar les Libs Email::
# mais en utilisant une livraison standard,  peut reservir !
use Net::SMTP;

#
# Main
#

# $debug  mettre  autre chose que 0 pour avoir une sortie  l'cran
my $debug = 0;

# pas trs propre le join... Manire rapide de rcuprer toute l'entre 
# standard dans une seule variable
my $message = join( "", <>) ;

# on commence par crer un container pour le futur message en sortie
my  $smtp = Net::SMTP->new('localhost');

# Par dfaut, l'emetteur est le compte local (on peut mettre n'imoprte quoi, ou presque...)
$smtp->mail($ENV{USER});

# on attache le message  Email::MIME
my $parser = Email::MIME->new($message);

if ( $debug ) {
	print  "Message Informations\n";
	printf "From      : %s\n", $parser->header("From");
	printf "To        : %s\n", $parser->header("To");
	printf "Date      : %s\n", $parser->header("Date");
	printf "Subject   : %s\n", $parser->header("Subject");
	printf "Mail size : %d KBytes\n", ( length($message) / 1024 );
}

# on complte le mail sortant :
$smtp->to( $parser->header("From") );
$smtp->data();
$smtp->datasend("To: " . $parser->header("From") . "\n" );
$smtp->datasend("From: $ENV{USER}\n");
my $date = ` date -R `;
chomp $date;
$smtp->datasend("Date: $date\n" );
$smtp->datasend("Subject: RE:" . $parser->header('Subject') ."\n");
#toujours une ligne blanche entre les en-ttes et le message...
$smtp->datasend("\n");
$smtp->datasend(sprintf( "Incoming Mail size : %d KBytes\n\n", ( length($message) / 1024 ) ) );

# maintenant, on attache le message au 'dcoupeur'
my $stripper = Email::MIME::Attachment::Stripper->new($message);

#On charge les pices jointes dans un tableau
my @attachments = $stripper->attachments;
if ( $debug ) {
	print "\nAttachments informations\n";
	printf "There are %d attachments in the message\n", $#attachments +1 ;
	foreach my $attach( @attachments ) {
		printf "Attach FileName      : %s\n", $attach->{filename};
		printf "Attach Type          : %s\n", $attach->{content_type};
		# l,  devient interressant : on a le corps de la pice jointe
		# dans $attach->{payload]
		printf "Attach contents Size : %d Bytes\n", length( $attach->{payload} );
		print  "    ----------\n";
	}
}
$smtp->datasend( "\nAttachments informations\n" );
$smtp->datasend(sprintf ("There are %d attachments in the message\n", $#attachments +1 ) );
foreach my $attach( @attachments ) {
	$smtp->datasend(sprintf( "Attach FileName      : %s\n", $attach->{filename}) );
	$smtp->datasend(sprintf( "Attach Type          : %s\n", $attach->{content_type}) );
	# l,  devient interressant : on a le corps de la pice jointe
	# dans $attach->{payload]
	$smtp->datasend(sprintf( "Attach contents Size : %d Bytes\n", length( $attach->{payload} ) ) );
	$smtp->datasend("    ----------\n");
}

# expdition du mail
$smtp->dataend();

$smtp->quit;
